package cz.cvut.fel.pr2;

import java.util.ArrayList;
import java.util.List;

public class AnyHolderCar implements BicycleVisitor {
    private List<AnyHolder<? extends Bicycle>> carHolders = new ArrayList<>(4);


    @Override
    public void accept(Bicycle bike) {
        addHolder(new AnyHolder<Bicycle>(bike));
    }

    @Override
    public void accept(MountainBike bike) {
        addHolder(new AnyHolder<MountainBike>(bike));
    }

    @Override
    public void accept(RoadBike bike) {
        addHolder(new AnyHolder<RoadBike>(bike));
    }

    private void addHolder(AnyHolder<? extends Bicycle> holder) {
        if (carHolders.size() < 4) {
            carHolders.add(holder);
        } else {
            throw new IndexOutOfBoundsException();
        }
    }

    public void print() {
        for (AnyHolder<? extends Bicycle> holder : carHolders) {
            System.out.println(holder.getClass().getSimpleName() + " holding " + holder.getItem().getClass().getSimpleName());
        }

    }
}
