package cz.cvut.fel.pr2;

public class Bicycle {
    public enum Color {
        RED("red", 1),
        BLUE("blue", 2),
        GREEN("green", 4);

        private final String name;
        private final int code;

        Color(String name, int code) {
            this.name = name;
            this.code = code;
        }

        public String getName() {
            return name;
        }

        public int getCode() {
            return code;
        }
    }

    public int cadence;
    public int gear;
    public int speed;
    public Color color;

    public Bicycle(int startCadence, int startSpeed, int startGear, Color color) {
        gear = startGear;
        cadence = startCadence;
        speed = startSpeed;
        this.color = color;
    }

    public void setCadence(int newValue) {
        cadence = newValue;
    }

    public void setGear(int newValue) {
        gear = newValue;
    }

    public void applyBrake(int decrement) {
        speed -= decrement;
    }

    public void speedUp(int increment) {
        speed += increment;
    }

    public void printDescription(){
        System.out.println("\nBike is " + this.color.getName() + " in gear " + this.gear
                + " with a cadence of " + this.cadence +
                " and travelling at a speed of " + this.speed + ". ");
    }

    public void visit(BicycleVisitor visitor) {
        visitor.accept(this);
    }
}
