package cz.cvut.fel.pr2;

public class TestBikes {
    public static void main(String[] args) {
        Bicycle bike01, bike02, bike03;

        bike01 = new Bicycle(20, 10, 1, Bicycle.Color.RED);
        bike02 = new MountainBike(20, 10, 5, Bicycle.Color.GREEN, "Dual");
        bike03 = new RoadBike(40, 20, 8, Bicycle.Color.BLUE, 23);

        bike01.printDescription();
        bike02.printDescription();
        bike03.printDescription();

        BicycleVisitor service1 = new BasicService();
        BicycleVisitor service2 = new MountainBikeService();
        BicycleVisitor service3 = new RoadBikeService();

        System.out.println("\nSingle dispatch:");
        service1.accept(bike01);
        service2.accept(bike02);
        service3.accept(bike03);

        System.out.println("\nDouble dispatch:");
        bike01.visit(service1);
        bike02.visit(service2);
        bike03.visit(service3);

        System.out.println("\nSingle dispatch:");
        Car car = new Car();
        car.accept(bike01);
        car.accept(bike02);
        car.accept(bike03);
        car.print();

        System.out.println("\nDouble dispatch:");
        car = new Car();
        bike01.visit(car);
        bike02.visit(car);
        bike03.visit(car);
        car.print();

        System.out.println("\nGeneric car:");
        AnyHolderCar car2 = new AnyHolderCar();
        bike01.visit(car2);
        bike02.visit(car2);
        bike03.visit(car2);
        car2.print();
    }
}
